<?php
/*
Plugin Name: wp_postdisplay
Plugin URI: http://taitan916.info
Description: 記事一覧をショートコードで表示するプラグイン。
Author: taitan916
Version: 1.1
Author URI: http://taitan916.info
*/

/*---------------
パラメータをカンマ区切りで[postDisp][/postDisp]に挟む

■パラメータ
limit(int)		表示数。デフォは全表示。
target(string)	リンクの遷移方法。selfかblankで指定。デフォはself。
cat(int)			カテゴリの指定。デフォルトは指定なし。
author(int)		投稿者の指定。デフォルトは指定なし。
li(bool)			liで囲むかどうか。デフォルトは囲まない。
date(bool)		投稿日時を表示させるかどうか。デフォルトは非表示。
---------------*/
function getPostDisplay( $the_content ) {
	if( strpos($the_content, '[postDisp]') === FALSE && strpos($the_content, '[/postDisp]') === FALSE ){
		return $the_content;
	} else {

		$pattern= '/\[postDisp\](.*?)\[\/postDisp\]/';
		preg_match_all($pattern, $the_content , $match);

		foreach( $match[1] as $val ){
			$parameter = $val;
		}

		//パラメータあり
		if( $parameter ){
			$tmp = explode(',', $parameter);
			$parameterList = array();

			for( $i = 0; $i < count($tmp); $i++ ){
				$tmp2 = explode('=', $tmp[$i]);
				$parameterList[$tmp2[0]] = $tmp2[1];
			}
		}

		$query	 = 'posts_per_page=';
		$query	 .= ( $parameterList['limit'] ) ? $parameterList['limit'] : -1;
		$query	 .= ( $parameterList['cat'] ) ? '&cat='.$parameterList['cat'] : '';
		$query	 .= ( $parameterList['author'] ) ? '&author='.$parameterList['author'] : '';
		$target	 .= ( $parameterList['target'] ) ? '_'.$parameterList['target'] : '_self';

		$blogPosts = get_posts($query);
		$postsBody = '';

		foreach($blogPosts as $val){
			if( $parameterList['li'] ) $postsBody .= '<li class="postdisp_li_'.$val->ID.' postdisp_li">';
			if( $parameterList['date'] ) $postsBody .= $val->post_date;
			$postsBody .= '
				<a href="'.get_permalink($val->ID).'" target="'.$target.'" class="postdisp_'.$val->ID.' postdisp">
					'.$val->post_title.'
				</a><br >
			';
			if( $parameterList['li'] ) $postsBody .= '</li>';
		}
		$the_content = str_replace('[postDisp]' . $parameter . '[/postDisp]', $postsBody, $the_content);

		return $the_content;
	}
}
add_filter('the_content', 'getPostDisplay');